/* Copyright (c) 2013  Eric Milles <eric.milles@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef ALACEncoder_h
#define ALACEncoder_h


#include "Platform.h"


class ALACEncoder
{
public:
	static const size_t ALAC_HEADER_SIZE;

	static void buildPacket(byte_t* packetBuffer, size_t packetCapacity,
		const byte_t* dataBuffer, size_t dataLength);

private:
	static void alacEncode(byte_t* buffer, int value, size_t length,
		size_t& bitOffset, size_t& byteOffset);

	ALACEncoder();
};


#endif // ALACEncoder_h
